let dataset = {
    t: null,
    aIds: [],
    a: 0,
    c: 0,
    w: 0
};

/**
 * @param {string} slctr
 * @return {Element|null}
 */
function q(slctr) {
    return document.querySelector(slctr);
}

/**
 * @param {string} id
 * @return {HTMLElement}
 */
function id(id) {
    return document.getElementById(id);
}

let startBlock =  q('.startblock'),
    questionBlock = q('.questionblock'),
    evalBlock = q('.evalblock'),
    allQuestions = id('all_questions'),
    correctAnswers = id('correct_answers'),
    wrongAnswers = id('wrong_answers'),
    percentage = id('percentage'),
    resultMessage = id('result_message')
;

function resetDataset() {
    dataset = { t: null, a: 0, c: 0, w: 0 };
}

function resetEvalBlock() {
    allQuestions.innerText = '';
    correctAnswers.innerText = '';
    wrongAnswers.innerText = '';
    percentage.innerText = '';
    resultMessage.innerText = '';
    questionBlock.setAttribute('style', 'display:none');
    evalBlock.setAttribute('style', 'display:none');
    startBlock.removeAttribute('style');
}

function evaluate() {
    let percentageVal = (dataset.c / dataset.a) * 100,
        msgMap = {
            0: "Ouf. Get a book!",
            25: 'Try again!',
            50: 'I wouldn\'t be satisfied with that.',
            75: 'Looks good, aim for something more',
            90: 'That\'s actually impressive!',
            100: 'I think you\'re ready. Go get \'em, champ!'
        },
        msgKeys = Object.keys(msgMap),
        i = 1,
        msg = msgMap['0']
    ;

    allQuestions.innerText = dataset.a.toString(10);
    correctAnswers.innerText = dataset.c.toString(10);
    wrongAnswers.innerText = dataset.w.toString(10);
    percentage.innerText = percentageVal.toString(10);

    for (i; i < msgKeys.length; i += 1) {
        if (parseInt(msgKeys[i], 10) < percentageVal) {
            msg = msgMap[msgKeys[i]];
        } else {
            i = msgKeys.length;
        }
    }

    resultMessage.innerText = msg;
    startBlock.setAttribute('style', 'display:none');
    questionBlock.setAttribute('style', 'display:none');
    evalBlock.removeAttribute('style');
}

function constructQuestion(data) {
    questionBlock.innerHTML = '';

}


function getNextQuestion() {
    let request = new XMLHttpRequest();
    request.onreadystatechange = function() {
        if (this.readyState === 4 && this.status === 200) {

        } else {
            alert('Error! Returned status ' + this.status.toString(10));
        }
    };
    request.open("POST", "/next", true);
    request.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
    request.send(JSON.stringify({ t: dataset.t, ids: dataset.aIds }));
}

function startQuiz() {
    dataset.t = id('topic').value;
    startBlock.setAttribute('style', 'display:none');
    questionBlock.removeAttribute('style');
    q('#target_topic').innerText = dataset.t;
}

id('start').addEventListener('click', startQuiz);

id('retry').addEventListener('click', function () {
    resetEvalBlock();
    resetDataset();
});

// DEBUG
id('dbg-rvrt').addEventListener('click', function() {
    startBlock.removeAttribute('style');
    questionBlock.setAttribute('style', 'display:none');
});